

#include "clienthandler.h"

#include "server.h"

#include "resources.h"



ClientHandler::ClientHandler (SOCKET s, Resources *r, bool e):remoteSocket(s), resources(r),echo (e),nick(0){}



/*Стартира сесия с клиента*/

void ClientHandler::manage (){



	char *str, msg[300];



	//прочитане на името не потребителя

	sendMessage ("Your Nick:");

	str = readShortString();

	if (!str)

		return;

	sendMessage ("\r\n");

	nick = new char [strlen(str)+1];

	strcpy (nick,str);



	//уведомяване на сървъра за започване на сесия

	resources->getServer()->clientSessionOpened (this);



	//--------------------------------------------------

	//цикъл на клиентската сесия

	//--------------------------------------------------

	do {

		delete str;

		str = readShortString ();



		if (str){

			sprintf (msg,"[%s]%s\r\n",getNick(),str);

			resources->getServer()->broadcast (msg);

		}

	}while (str && strcmp (str,"quit") != 0);

	//--------------------------------------------------

	//край на клиентската сесия

	//--------------------------------------------------



	if (str)

		delete str;



}



/*Изпраща текстово съобщение до клиента*/

void ClientHandler::sendMessage (char *message){

	try {

		send (remoteSocket, message, strlen (message), 0);

	} catch (...) {};



}



char *ClientHandler::getNick (){

	if (nick)

		return nick;

	return "";

}





ClientHandler::~ClientHandler (){

	resources->getServer()->clientSessionClosed (this);

	closesocket (remoteSocket);

	if (nick)

		delete nick;

}





//Прочита низ от клиентския socket. Низа се чете до знак

//за нов ред



char* ClientHandler::readShortString (){



	char *str = new char [255];

	memset (str,0,255);

	

	int c, recvResult;



	//четем само по един байт, до достигане на нова ред

	//или разпадане на връзката



	for (c=0; c<254 && 

				  (recvResult=recv(remoteSocket,str+c,1,0))==1 && 

				  str[c] != 13;c++)

		if (echo)

			send (remoteSocket,str+c,1,0);



	if (str[c] != 13){

		delete str;

		return NULL;

	}



	str[c] = 0;

	recv(remoteSocket,str+c+1,1,0);		//пропускаме символа #10 

										//който следва символа #13

	

	return str;

}



