

#include "server.h"

#include "clienthandler.h"

#include "resources.h"





/*

Параметри за нишката

*/

struct ThreadParams{



	ThreadParams (Resources *r, SOCKET s,bool e):

			resources(r),clientSocket(s),echo(e){};



	Resources *resources;

	SOCKET clientSocket;

	bool echo;

};

	/*

	Входна точка на нишките за обработка на клиенти

	*/

DWORD WINAPI ConnectionThread (LPVOID params){



	try {



		ThreadParams *p = (ThreadParams*)params;



		p->resources->getConsole () << "Connection accepted\n";



		ClientHandler handler (p->clientSocket, p->resources, p->echo);

		handler.manage();



		delete p;



	} catch (...){

	};



	return 0;

}









Server::Server (int port, char *logFileName, bool e):serverPort (port), echo(e){

	resources = new Resources (logFileName, this);

}

	

//стартира сървъра на съответния порт

bool Server::start (){

	if (!prepareListenSocket ())

		return false;



	resources->getConsole() << "Chat Server running on port: " << serverPort << endl;

	

	//Socket на отдалечената връзка

	SOCKET	remoteSocket;



	//Идентификатор на нишка

	DWORD ThreadId = 0;



	//параметри на нишката

	ThreadParams *threadParams;

	

	//--------------------------------------------------------------

	// Обработка на заявки

	//--------------------------------------------------------------

	while (true){



		//--------------------------------------------------------------

		// Синхронно чакане на входна заявка

		//--------------------------------------------------------------



		remoteSocket = accept(listenSocket,			// Listening socket

							  NULL,					// Optional client address

							  NULL);



		if (remoteSocket == INVALID_SOCKET)	{

			return false;

		}

		

		//--------------------------------------------------------------

		// Приемане на входна заявка

		//--------------------------------------------------------------

		threadParams = new ThreadParams (resources,remoteSocket,echo);

		if (!CreateThread (0,0,ConnectionThread,(LPVOID)threadParams,0,&ThreadId)){

			closesocket (remoteSocket);

		}

				



	}//цикъл на обработка на заявки

}





Server::~Server(){

	delete resources;

}





/*Този метод се използва от клиентите, които уведомяват сървъра

за приключване на сесията*/

void Server::clientSessionClosed (ClientHandler *handler){

	char msg[200];

	sprintf (msg, "***%s left the chat\r\n",handler->getNick());

	broadcast (msg);



	vector<ClientHandler*>::iterator it = clients.begin();



	while (*it != handler && it != clients.end())

		it++;



	if (it != clients.end())

		clients.erase (it);



}



/*Този метод се използва от клиентите, които уведомяват

дървъра за успешно начало на нова сесия*/

void Server::clientSessionOpened (ClientHandler *handler){

	clients.push_back (handler);



	char msg[200];

	sprintf (msg, "***%s joined the chat\r\n",handler->getNick());

	broadcast (msg);

}



/*Този метод се използва от клиентите, които искат да

изпратят съобщение до останалите клиенти*/



void Server::broadcast (char *message){

	unsigned i;

	for (i = 0; i < clients.size(); i++)

		clients[i]->sendMessage (message);



	resources->getLogFile() << message << endl;

}



/*

Започва подслушване на зададения порт.

*/

bool Server::prepareListenSocket (){



								//създава се нов socket

	listenSocket = socket (AF_INET,SOCK_STREAM,IPPROTO_TCP);





	if (listenSocket == INVALID_SOCKET)

		return false;

	

								// Fill in the address structure

	SOCKADDR_IN saServer;	



	saServer.sin_family = AF_INET;

								// Let WinSock supply address

	saServer.sin_addr.s_addr = INADDR_ANY;	

								// Set the port

	saServer.sin_port = htons (serverPort);		





	int nRet;



								//Обвързване с порта с порта

	nRet = bind(listenSocket,				// Socket 

				(LPSOCKADDR)&saServer,		// Our address

				sizeof(struct sockaddr));	// Size of address structure



	if (nRet == SOCKET_ERROR) {

		closesocket(listenSocket);

		return false;

	}



	

	nRet = listen(listenSocket,					// Bound socket

				  SOMAXCONN);					// Number of connection request queue

	if (nRet == SOCKET_ERROR) {

		closesocket(listenSocket);

		return false;

	}



	return true;

}





