#ifndef __SERVER_H

#define __SERVER_H



#include "windows.h"



#include <vector>

#include <iostream>

#include <fstream>



using namespace std;



class ClientHandler;

class Resources;



class Server{

	/*

	Управлява сървърната логика. Стартира сървър на 

	определения порт, приема заявки и стартира 

	в нова нишка ClientHandlerза всяка приета заявка.

	*/

public:

	Server (int port, char *logFileName, bool e);

	

	//стартира сървъра на съответния порт

	bool start ();



	~Server();



	//------------------------

	//Интерфейс, позлван за комуникация между

	//клиентите

	//------------------------



	/*Този метод се използва от клиентите, които уведомяват сървъра

	за приключване на сесията*/

	void clientSessionClosed (ClientHandler *handler);



	/*Този метод се използва от клиентите, които уведомяват

	дървъра за успешно начало на нова сесия*/

	void clientSessionOpened (ClientHandler *handler);



	/*Този метод се използва от клиентите, които искат да

	изпратят съобщение до останалите клиенти*/



	void broadcast (char *message);



private:



	//---------------------------------------------------------



	/*

	Порт, на който сървъра подслушва.

	*/

	int serverPort;	



	/*

	Socket, който ще приема връзки

	*/

	SOCKET listenSocket;



	/*

	Сървърни ресурси

	*/

	Resources *resources;



	/* Ехо режим */

	bool echo;



	/* Списък с активните клиенти */

	vector <ClientHandler*> clients;



	//---------------------------------------------------------



	/*

	Започва подслушване на зададения порт.

	*/

	bool prepareListenSocket ();

};



#endif

